﻿using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Controls;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GroupingNodes
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {      
        public MainWindow()
        {
            InitializeComponent();
            diagram.PortVisibility = PortVisibility.Visible;
            diagram.PageSettings.PageBorderBrush = new SolidColorBrush(Colors.Transparent);
            diagram.Connectors = new ObservableCollection<ConnectorViewModel>();
            diagram.Nodes = new ObservableCollection<NodeViewModel>();
            diagram.Groups = new ObservableCollection<GroupViewModel>();

            NodeViewModel n = AddNode(50, 200, 200, 300);
            NodeViewModel n1 = AddNode(50, 100, 150, 350);
            NodeViewModel n2 = AddNode(50, 100, 250, 350);
            NodeViewModel n3 = AddNode(50, 100, 150, 400);
            NodeViewModel n4 = AddNode(50, 100, 250, 400);
            NodeViewModel n5 = AddNode(50, 100, 150, 450);
            NodeViewModel n6 = AddNode(50, 100, 250, 450);

            GroupViewModel grp = new GroupViewModel();
            grp.Nodes = new ObservableCollection<NodeViewModel>()
            {
                n,n1,n2,n3,n4,n5,n6
            };

            (diagram.Groups as ObservableCollection<GroupViewModel>).Add(grp);           
           
        }

        private NodeViewModel AddNode(double x, double y, double offx, double offy)
        {
            NodeViewModel node = new NodeViewModel();
            node.UnitHeight = x;
            node.UnitWidth = y;
            node.OffsetX = offx;
            node.OffsetY = offy;
            node.Ports = new ObservableCollection<NodePortViewModel>()
            {
            new NodePortViewModel()
            {
             UnitHeight = 10,
             UnitWidth = 10,
             NodeOffsetY = 0.25,
             NodeOffsetX = 0.5,
           }
          };
            node.Annotations = new ObservableCollection<IAnnotation>()
            {
                new AnnotationEditorViewModel()
                {
                    Content ="Text"
                }
            };
            node.Shape = new RectangleGeometry() { Rect = new Rect(10, 10, 50, 50) };
            (diagram.Nodes as ObservableCollection<NodeViewModel>).Add(node);
            return node;
        }
    }

}

